package org.bfkj.api;


import jakarta.servlet.http.HttpServletRequest;
import org.bfkj.application.AuthApplicationImpl;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.HashMap;
import java.util.Map;

@RestController
@RequestMapping("foxlibc")
//@CrossOrigin
public class AuthManageApi {

    @Autowired
    AuthApplicationImpl authApplication;

    @PostMapping("getToken")
    public Object getToken(@RequestBody Map<String, String> params, HttpServletRequest httpServletRequest) {
        String sessionID = httpServletRequest.getSession().getId();
        return authApplication.getToken(params, sessionID);
    }

    @PostMapping("application-token")
    public Object application_token(@RequestBody Map<String, String> params, HttpServletRequest httpServletRequest) {
        String sessionID = httpServletRequest.getSession().getId();
        Map rsData =  (Map)authApplication.getToken(params, sessionID);
        HashMap<String, Object> rsMap = new HashMap<>();
        try {
            rsMap.put("code",rsData.get("code"));
            HashMap<String, Object> dataMap = new HashMap<>();
            dataMap.put("expireTime",((Map)rsData.get("returnData")).get("app_effective"));
            dataMap.put("appToken",((Map)rsData.get("returnData")).get("app_token"));
            rsMap.put("data",dataMap);
            rsMap.put("message",rsData.get("message"));
        }catch (Exception e){
            rsMap.put("message",rsData.get("message"));
        }
        return rsMap;
    }


    // todo 新增refreshToken()
    @PostMapping("refreshToken")
    public Object refreshToken(@RequestBody Map<String, String> params) {
        return authApplication.refreshToken(params);
    }

    /**
     * 获取验证码
     *
     * @param params {appId:"",token:""}
     * @return 验证码执行结果信息
     */
    @PostMapping("getVCode") //todo getVCode()
    public Object getVCode(@RequestBody Map<String, Object> params) {
        return authApplication.getVCode(params);
    }

    /**
     * 用户登录并获取用户权限信息
     *
     * @param data{”token“：”“，”appid“：”“，”username“：”“，”password“：”“}
     * @return 获取用户权限信息
     */
    @PostMapping("sign-in")
    public Map<String, Object> signIn(@RequestBody Map<String, String> data) {
        return authApplication.signIn(data);
    }
    @PostMapping("loginOut")
    public Map<String, Object>loginOut(@RequestBody Map<String, String> params) {
        return authApplication.loginOut(params);
    }

    @PostMapping("getAuth")
    public Map<String, Object> getAuth(@RequestBody Map<String, String> params) {
        return authApplication.getAuth(params);
    }


    @PostMapping("/initColumnSet")
    public Map<String, Object> initColumnSet(@RequestBody Map<String, Object> data) {
        return authApplication.initColumnSet(data);
    }

}
