package org.bfkj.api;

import org.bfkj.application.AuthApplicationImpl;
import org.bfkj.application.ServiceInputControl;
import org.bfkj.utils.MapTools;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;
import java.util.Map;

//todo  控制类 API（start，stop）

@RestController
@RequestMapping("controlApi")
public class ControllerApi {
    @Autowired
    AuthApplicationImpl authApplication;

    /***
     * 主动采集与被动采集的启动
     * @param headers
     * @param params
     * @return
     */
    @PostMapping("start")
    @ResponseBody
    public Map<String,Object> start(@RequestHeader Map<String, String> headers, @RequestBody Map<String, Object> params) {
        String verificationToke = authApplication.verificationUserToken(headers);
        if (!MapTools.isBlank(verificationToke)) {
            HashMap<String, Object> errMap = new HashMap<>();
            errMap.put("code","-1");
            errMap.put("message","用户令牌验证失败：" + verificationToke);
            return errMap;
        }
        //令牌校验
        return ServiceInputControl.startOrStop(params, "1");
    }
    /**
     * 主动采集与被动采集的停止
     *
     * @param headers
     * @param params
     * @return
     */
    @PostMapping("stop")
    @ResponseBody
    public Map<String,Object> stop(@RequestHeader Map<String, String> headers, @RequestBody Map<String, Object> params) {
        String verificationToke = authApplication.verificationUserToken(headers);
        if (!MapTools.isBlank(verificationToke)) {
            HashMap<String, Object> errMap = new HashMap<>();
            errMap.put("code","-1");
            errMap.put("message","用户令牌验证失败：" + verificationToke);
            return errMap;
        }
        return ServiceInputControl.startOrStop(params, "0");
    }
}
