package org.bfkj.api;

import org.bfkj.application.DataProcess;
import org.bfkj.config.ObjectMap;
import org.bfkj.utils.MapTools;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;
import java.util.Map;
import java.util.Objects;


@RestController
@RequestMapping("externalApi/openApi")
public class TransferData {
    /**
     * @param headers headers参数
     * @param params 请求参数
     * @return 返回值
     */
    @PostMapping("sendData")
    @ResponseBody
    public Object sendData(@RequestHeader Map<String, String> headers, @RequestBody Map<String, Object> params) {
        System.out.println("params"+params);
        Object serviceId = params.get("serviceId");
        if (Objects.isNull(serviceId)) {
            HashMap<String, Object> errMap = new HashMap<>();
            errMap.put("code", "-1");
            errMap.put("message", "缺失必要的参数：serviceId" + params);
            return errMap;
        }
        //通过服务ID 查询对应服务的服务类型是否为1，如果时则继续，否则返回
        DataProcess dataProcessObj = ObjectMap.getordropInput(serviceId.toString(), true);//获取数据输出处理对象
        if (null == dataProcessObj || !MapTools.isBlank(dataProcessObj.getErrorMessage())) {
            HashMap<String, Object> errMap = new HashMap<>();
            errMap.put("code", "-1");
            errMap.put("message", "服务不可用：" + (null == dataProcessObj ? "" : dataProcessObj.getErrorMessage()));
            return errMap;
        }
        return dataProcessObj.processData(params, headers.get("user_id"));
    }
}
