package org.bfkj.config;

import com.fasterxml.jackson.databind.ObjectMapper;
import com.fasterxml.jackson.databind.SerializationFeature;
import com.fasterxml.jackson.datatype.jsr310.JavaTimeModule;

import java.text.SimpleDateFormat;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;

public class AppConfig {
    public static String REMOTE_DB_CONNECT = "";
    public static String REMOTE_DB_LOG_CONNECT = "";
    public static String serviceURL = "";
    public static String WORK_ID;
    public static Integer SERVICE_ERR_MAX = 3; //服务最大连续异常次数

    public static final SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

    public static HashMap<String, HashSet<Object>> event6Map = new HashMap<>();//用于事件6是否存在的内存检测

    public static String SOURCE_DATA="";

    public static HashMap<String, String> staticEvent = new HashMap<>() {{
        put("select", "0");
        put("update", "2");
        put("insert", "1");
        put("delete", "3");
    }};


    public static Map<String, String> eventSQL = new HashMap<>() {{//用于表名方式组建SQL的基本语句
        put("0", "select 字段 from 表名");
        put("1", "insert into 表名(字段) values(值) ");
        put("2", "update 表名 set 值 ");
        put("3", "delete from 表名 ");
    }};

    public static final ObjectMapper mapper = new ObjectMapper();
    static {
        mapper.registerModule(new JavaTimeModule());
        mapper.configure(SerializationFeature.WRITE_DATES_AS_TIMESTAMPS, false); //关闭
    }
}
