package org.bfkj.config;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

@Configuration
public class ElasticsearchConfig {
    @Value("${isEs.open}")
    private boolean open;
    @Value("${isEs.scheme}")
    private String scheme;
    @Value("${isEs.hostname}")
    private String hostname;
    @Value("${isEs.port}")
    private Integer port;
    @Value("${isEs.auth}")
    private Boolean auth;
    @Value("${isEs.username}")
    private String username;
    @Value("${isEs.password}")
    private String password;
    @Value("${isEs.successIndexName}")
    private String successIndexName;

    @Value("${isEs.errorIndexName}")
    private String errorIndexName;

    @Bean("ElasticBean")
    public ElasticsearchConfig EsConfig() {
        ElasticsearchConfig elasticsearchConfig = new ElasticsearchConfig();
        elasticsearchConfig.open = open;
        elasticsearchConfig.scheme = scheme;
        elasticsearchConfig.hostname = hostname;
        elasticsearchConfig.port = port;
        elasticsearchConfig.auth = auth;
        elasticsearchConfig.username = username;
        elasticsearchConfig.password = password;
        elasticsearchConfig.errorIndexName = errorIndexName;
        elasticsearchConfig.successIndexName = successIndexName;
        return elasticsearchConfig;

    }

    public boolean isOpen() {
        return open;
    }

    public void setOpen(boolean open) {
        this.open = open;
    }

    public String getScheme() {
        return scheme;
    }

    public void setScheme(String scheme) {
        this.scheme = scheme;
    }

    public String getHostname() {
        return hostname;
    }

    public void setHostname(String hostname) {
        this.hostname = hostname;
    }

    public Integer getPort() {
        return port;
    }

    public void setPort(Integer port) {
        this.port = port;
    }

    public Boolean getAuth() {
        return auth;
    }

    public void setAuth(Boolean auth) {
        this.auth = auth;
    }

    public String getUsername() {
        return username;
    }

    public void setUsername(String username) {
        this.username = username;
    }

    public String getPassword() {
        return password;
    }

    public void setPassword(String password) {
        this.password = password;
    }

    public String getSuccessIndexName() {
        return successIndexName;
    }

    public void setSuccessIndexName(String successIndexName) {
        this.successIndexName = successIndexName;
    }

    public String getErrorIndexName() {
        return errorIndexName;
    }

    public void setErrorIndexName(String errorIndexName) {
        this.errorIndexName = errorIndexName;
    }
}
