//package org.bfkj.protocol;
//
//import com.ibm.mq6.*;
//import org.bfkj.utils.LogUtils;
//import org.bfkj.utils.MapTools;
//
//import java.io.IOException;
//import java.util.ArrayList;
//import java.util.HashMap;
//import java.util.Map;
//import java.util.Objects;
//
//public class MyIbmMQ6 {
//    private MQQueueManager mqQueueManager;
//    /**
//     * 采集kafka数据
//     *
//     * @param data 连接参数信息
//     * @return 读取内容信息
//     */
//    public Map<String,Object> readMethod(String sourceObjectName,String connectConfig,Map<String, Object> data) {
//        if (Objects.isNull(sourceObjectName) || Objects.isNull(connectConfig) || Objects.isNull(getMyConnect(connectConfig))) {
//            HashMap<String, Object> errMap = new HashMap<>();
//            errMap.put("code","-1");
//            errMap.put("message","用户令牌验证失败：" + (Objects.isNull(sourceObjectName) ? "队列为空：发送数据为 " : "连接为空:发送数据为：") + data);
//            return errMap;
//        }
//        Map<String, Object> connectConfigMaps = getMyConnect(connectConfig);
//        Map<String, Object> returnDataMaps = new HashMap<>();
//        try {
//            mqQueueManager = getMqQueueManager(connectConfigMaps);
//            MQQueue queue = mqQueueManager.accessQueue(connectConfigMaps.get("receiveQueueName").toString(), MQC.MQOO_INPUT_AS_Q_DEF | MQC.MQOO_OUTPUT | MQC.MQOO_INQUIRE);
//            MQGetMessageOptions gmo = new MQGetMessageOptions();
//            gmo.waitInterval = Objects.isNull(connectConfigMaps.get("receiveTimeout")) ? 300 : Integer.parseInt(connectConfigMaps.get("receiveTimeout").toString());
//            int depth = queue.getCurrentDepth();
//            if (depth > 0) {
//                MQMessage message = new MQMessage();
//                queue.get(message, gmo);
//                if (message.getDataLength() > 0) {
//                    returnDataMaps.put("dataContent", message.readStringOfByteLength(message.getDataLength()));
//                }
//            }
//        } catch (MQException | IOException e) {
//            HashMap<String, Object> errMap = new HashMap<>();
//            errMap.put("code","-1");
//            errMap.put("message",LogUtils.getException(e));
//            return errMap;
//
//        }
//
//        HashMap<String, Object> successMap = new HashMap<>();
//        successMap.put("code","0");
//        successMap.put("returnData",new ArrayList<Map<String, Object>>() {{
//            add(returnDataMaps);
//        }});
//        return successMap;
//    }
//
//    /**
//     * 数据发送到kafka
//     *
//     * @param sendData 发送数据，及连接信息
//     * @return 发送结果信息
//     */
//    public Map<String,Object> sendMethod(String sourceObjectName,String connectConfig, Map<String, Object> sendData) {
//        if (Objects.isNull(sourceObjectName) || Objects.isNull(connectConfig) || Objects.isNull(getMyConnect(connectConfig))) {
//            HashMap<String, Object> errMap = new HashMap<>();
//            errMap.put("code","-1");
//            errMap.put("message",(Objects.isNull(sourceObjectName) ? "队列为空 " : "连接为空:发送数据为：") + sendData);
//            return errMap;
//        }
//        Object data = sendData.get("dataContent");
//        if (Objects.isNull(data)) {
//            HashMap<String, Object> errMap = new HashMap<>();
//            errMap.put("code","-1");
//            errMap.put("message","数据内容为空 " + sendData);
//            return errMap;
//        }
//        Map<String, Object> connectConfigMaps = getMyConnect(connectConfig);
//        try {
//            mqQueueManager = getMqQueueManager(connectConfigMaps);
//            MQQueue queue = mqQueueManager.accessQueue(sourceObjectName.toString(), MQC.MQOO_INPUT_AS_Q_DEF | MQC.MQOO_OUTPUT | MQC.MQOO_INQUIRE | MQC.MQOO_FAIL_IF_QUIESCING);
//            MQMessage mqMessage = new MQMessage();
//            if (connectConfigMaps.containsKey("characterSet")) {
//                mqMessage.characterSet = Integer.parseInt(connectConfigMaps.get("characterSet").toString());
//            }
//            mqMessage.write(data.toString().getBytes());
//            MQPutMessageOptions pmo = new MQPutMessageOptions();
//            queue.put(mqMessage, pmo); //发送消息
//
//            HashMap<String, Object> successMap = new HashMap<>();
//            successMap.put("code","0");
//            successMap.put("returnData",null);
//            return successMap;
//        } catch (MQException | IOException e) {
//            HashMap<String, Object> errMap = new HashMap<>();
//            errMap.put("code","-1");
//            errMap.put("message",LogUtils.getException(e));
//            return errMap;
//        }
//    }
//
//    private MQQueueManager getMqQueueManager(Map<String, Object> config) throws MQException {
//        if (Objects.isNull(mqQueueManager)) {
//            MQEnvironment.hostname = config.get("hostname").toString();
//            MQEnvironment.channel = config.get("channel").toString();
//            MQEnvironment.port = Integer.parseInt(config.get("port").toString());
//            MQEnvironment.CCSID = Integer.parseInt(config.get("ccsid").toString());
//            if (config.containsKey("username") && config.containsKey("password") && Objects.nonNull(config.get("username")) && Objects.nonNull(config.get("password"))) {
//                MQEnvironment.password = config.get("password").toString();
//                MQEnvironment.userID = config.get("username").toString();
//            }
//            mqQueueManager = new MQQueueManager(config.get("queueManager").toString());
//        }
//        return mqQueueManager;
//    }
//
//    public Map<String, Object> getMyConnect(Object connectConfig) {
//        if (connectConfig instanceof Map) {
//            return (Map<String, Object>) connectConfig;
//        } else {
//            return MapTools.mapStrToMap_connect(connectConfig.toString());
//        }
//    }
//
//    /**
//     * 关闭kafka信息
//     *
//     * @throws Exception
//     */
//    public void close() {
//        if (Objects.nonNull(mqQueueManager)) {
//            try {
//                mqQueueManager.close();
//            } catch (MQException e) {
//            }
//            mqQueueManager = null;
//            System.out.println("mqQueueManager关闭");
//        }
//    }
//}
