package org.bfkj.utils;

import org.bfkj.application.DataProcess;
import org.bfkj.application.ServiceInputControl;
import org.bfkj.config.AppConfig;
import org.bfkj.config.ObjectMap;

import java.util.Date;
import java.util.HashMap;
import java.util.Objects;

public class ScheduleTask implements Runnable {
    private String id; // 服务ID

    public String getId() {
        return id;
    }

    Integer loopCount;
    int count = 0;
    public Date taskValid;
    public Date taskInvalid;
    public void setId(String id) {
        this.id = id;
    }

    /**
     * @param id 任务ID
     */
    public ScheduleTask(String id, Integer loopCount, Date taskValid, Date taskInvalid) {
        this.id = id;
        this.loopCount = loopCount;
        this.taskValid = taskValid;
        this.taskInvalid = taskInvalid;

    }

    @Override
    public void run() {
        if (Objects.nonNull(taskInvalid) && taskInvalid.before(new Date())) {
            ServiceInputControl.stop(id);
            return;
        }
        if (Objects.isNull(taskValid) || taskValid.after(new Date())) {
            if ((Objects.isNull(loopCount) || count < loopCount)) {
                count++;
                DataProcess dataProcess = ObjectMap.getordropInput(id);
                if (Objects.isNull(dataProcess) || Objects.nonNull(dataProcess.getErrorMessage())) {
                    LogUtils.log("run: 1", "-1",  null,"启动服务失败，获取采集对象异常:" + (Objects.isNull(dataProcess) ? "" : dataProcess.getErrorMessage()), id,"服务编号：" + id, null,null,null);//无条件记录数据接收日志
                }
                dataProcess.processData(new HashMap<>() {{
                    put("dataContent", "1");
                    put("event", "1");
                }});

            } else {
                ServiceInputControl.stop(id);
            }
        }
    }

    public void setLoopCount(Integer loopCount) {
        this.loopCount = loopCount;
    }
}
